diff -urpN --exclude-from=/home/davej/.exclude bk-linus/drivers/char/agp/agp.c linux-2.5/drivers/char/agp/agp.c
--- bk-linus/drivers/char/agp/agp.c	2002-11-20 19:34:55.000000000 +0000
+++ linux-2.5/drivers/char/agp/agp.c	2002-11-21 17:57:49.000000000 +0000
@@ -1003,6 +1003,14 @@ static struct {
 		.chipset_setup	= sis_generic_setup
 	},
 	{
+		.device_id	= PCI_DEVICE_ID_SI_651,
+		.vendor_id	= PCI_VENDOR_ID_SI,
+		.chipset	= SIS_GENERIC,
+		.vendor_name	= "SiS",
+		.chipset_name	= "651",
+		.chipset_setup	= sis_generic_setup
+	},
+	{
 		.device_id	= PCI_DEVICE_ID_SI_650,
 		.vendor_id	= PCI_VENDOR_ID_SI,
 		.chipset	= SIS_GENERIC,
@@ -1150,6 +1158,14 @@ static struct {
 		.chipset_setup	= via_generic_setup
 	},
 	{
+		.device_id	= PCI_DEVICE_ID_VIA_8377_0,
+		.vendor_id	= PCI_VENDOR_ID_VIA,
+		.chipset	= VIA_APOLLO_KT400,
+		.vendor_name	= "Via",
+		.chipset_name	= "Apollo Pro KT400",
+		.chipset_setup	= via_generic_setup
+	},
+	{
 		.device_id	= PCI_DEVICE_ID_VIA_8653_0,
 		.vendor_id	= PCI_VENDOR_ID_VIA,
 		.chipset	= VIA_APOLLO_PRO,
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/include/linux/pci_ids.h linux-2.5/include/linux/pci_ids.h
--- bk-linus/include/linux/pci_ids.h	2002-11-21 02:24:01.000000000 +0000
+++ linux-2.5/include/linux/pci_ids.h	2002-11-21 18:04:50.000000000 +0000
@@ -1018,6 +1020,7 @@
 #define PCI_DEVICE_ID_VIA_8361		0x3112 
 #define PCI_DEVICE_ID_VIA_8233A		0x3147
 #define PCI_DEVICE_ID_VIA_8235		0x3177
+#define PCI_DEVICE_ID_VIA_8377_0	0x3189
 #define PCI_DEVICE_ID_VIA_86C100A	0x6100
 #define PCI_DEVICE_ID_VIA_8231		0x8231
 #define PCI_DEVICE_ID_VIA_8231_4	0x8235
diff -urpN --exclude-from=/home/davej/.exclude bk-linus/include/linux/agp_backend.h linux-2.5/include/linux/agp_backend.h
--- bk-linus/include/linux/agp_backend.h	2002-11-21 02:23:44.000000000 +0000
+++ linux-2.5/include/linux/agp_backend.h	2002-11-21 18:04:37.000000000 +0000
@@ -61,6 +61,7 @@ enum chipset_type {
 	VIA_APOLLO_PRO,
 	VIA_APOLLO_KX133,
 	VIA_APOLLO_KT133,
+	VIA_APOLLO_KT400,
 	SIS_GENERIC,
 	AMD_GENERIC,
 	AMD_IRONGATE,
